## tlsh 4.12.1+ds

=== CMakeLists.txt ===
# TLSH is provided for use under two licenses: Apache OR BSD.
# Users may opt to use either license depending on the license
# restictions of the systems with which they plan to integrate
# the TLSH code.
#
# ==============
# Apache License
# ==============
# Copyright 2013 Trend Micro Incorporated
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# ===========
# BSD License
# ===========
# Copyright (c) 2013, Trend Micro Incorporated
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.

# 3. Neither the name of the copyright holder nor the names of its contributors
#    may be used to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 2.6)

project(TLSH)

set(VERSION_MAJOR 4)
set(VERSION_MINOR 12)
set(VERSION_PATCH 1)

# TLSH uses only half the counting buckets.
# It can use all the buckets now.
if(NOT TLSH_BUCKETS_48 AND NOT TLSH_BUCKETS_128 AND NOT TLSH_BUCKETS_256)
set(TLSH_BUCKETS_128 1)
endif()
if(TLSH_BUCKETS_48 EQUAL 1)
  set(TLSH_HASH "min hash")
  add_definitions(-DBUCKETS_48)
endif()
if(TLSH_BUCKETS_128 EQUAL 1)
  set(TLSH_HASH "compact hash")
  add_definitions(-DBUCKETS_128)
endif()
if(TLSH_BUCKETS_256 EQUAL 1)
  set(TLSH_HASH "full hash")
  add_definitions(-DBUCKETS_256)
endif()

# TLSH uses 1 byte checksum. The collision rate is 1 in 24.
# It can use 3 bytes checksum now. That collision rate in 1 in 5800.
if(NOT TLSH_CHECKSUM_0B AND NOT TLSH_CHECKSUM_1B AND TLSH_CHECKSUM_3B)
set(TLSH_CHECKSUM_1B 1)
endif()

if(TLSH_CHECKSUM_0B EQUAL 1)
  set(TLSH_CHECKSUM "no checksum")
  add_definitions(-DCHECKSUM_0B)
endif()
if(TLSH_CHECKSUM_1B EQUAL 1)
  set(TLSH_CHECKSUM "1 byte checksum")
endif()
if(TLSH_CHECKSUM_3B EQUAL 1)
  set(TLSH_CHECKSUM "3 bytes checksum")
  add_definitions(-DCHECKSUM_3B)
endif()

# setting TLSH_DISTANCE_PARAMETERS to 1 allows you to set command line arguments
# to set - and hence experiment with the distance parameters
#	by default this is zero
set(TLSH_DISTANCE_PARAMETERS 0)

# write a file with the VERSION information
file(REMOVE VERSION)
file(WRITE VERSION 
  "// This file is generated by cmake.  Modify\n"
  "// CMakeLists.txt to change the VERSION numbers\n"
  "TLSH version: ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH} ${TLSH_HASH}, ${TLSH_CHECKSUM}\n")
  
file(REMOVE include/version.h)
file(REMOVE include/tlsh_version.h)
file(WRITE include/tlsh_version.h
  "/****************************************************\n"
  " * This file is generated by cmake.  Modify the top\n"
  " * level CMakeLists.txt to change the VERSION numbers\n"
  " ****************************************************/\n\n"
  "#define VERSION_MAJOR ${VERSION_MAJOR}\n"
  "#define VERSION_MINOR ${VERSION_MINOR}\n"
  "#define VERSION_PATCH ${VERSION_PATCH}\n"
  "#define TLSH_HASH \"${TLSH_HASH}\"\n"
  "#define TLSH_CHECKSUM \"${TLSH_CHECKSUM}\"\n")
if(TLSH_DISTANCE_PARAMETERS EQUAL 1)
file(APPEND include/tlsh_version.h
  "#define TLSH_DISTANCE_PARAMETERS ${TLSH_DISTANCE_PARAMETERS}\n")
endif()

if (CMAKE_BUILD_TYPE STREQUAL Debug)
    if(CMAKE_COMPILER_IS_GNUCXX)
        set(CMAKE_CXX_FLAGS "-g")
    endif()
else(CMAKE_BUILD_TYPE STREQUAL Debug)
    if(MSVC)
        set(CMAKE_CXX_FLAGS "/O2")        ## Optimize
    else(MSVS)
        set(CMAKE_CXX_FLAGS "-O3")
    endif()
endif(CMAKE_BUILD_TYPE STREQUAL Debug)

if(MSVC)
    add_definitions(-DWINDOWS -DTLSH_LIB)
    include_directories(Windows)
endif()

# user can override CXX; make sure tests link and load properly regardless of LD_LIBRARY_PATH
if(CMAKE_COMPILER_IS_GNUCXX)
    # issue #116 Library will not compile on CENTOS 7
    # set(CMAKE_EXE_LINKER_FLAGS "-static-libstdc++")
    set(CMAKE_EXE_LINKER_FLAGS "-static-libgcc")
endif()

# from https://stackoverflow.com/questions/5395309/how-do-i-force-cmake-to-include-pthread-option-during-compilation
set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
# This flag seems to only be for older versions of CMake, such as https://cmake.org/cmake/help/v3.2/module/FindThreads.html
set(THREADS_PREFER_PTHREAD_FLAG TRUE)
find_package(Threads REQUIRED)

enable_testing()

include_directories(include)
add_subdirectory(src)
add_subdirectory(test)
add_subdirectory(utils)
add_subdirectory(Testing)

if(MSVC)
    add_subdirectory(Windows)
endif()

set(CPACK_GENERATOR "TGZ")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "TLSH-${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
set(CPACK_PACKAGE_VERSION_MAJOR "${VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${VERSION_PATCH}")
set(CPACK_SOURCE_IGNORE_FILES
"~$"
"^${PROJECT_SOURCE_DIR}/bin/"
"^${PROJECT_SOURCE_DIR}/lib/"
"^${PROJECT_SOURCE_DIR}/build/"
"^${PROJECT_SOURCE_DIR}/py_ext/data/"
"^${PROJECT_SOURCE_DIR}/py_ext/build/"
"^${PROJECT_SOURCE_DIR}/Testing/tmp/"
"^${PROJECT_SOURCE_DIR}/CMakeFiles/"
)
include(CPack)

=== src/CMakeLists.txt ===
# TLSH is provided for use under two licenses: Apache OR BSD.
# Users may opt to use either license depending on the license
# restictions of the systems with which they plan to integrate
# the TLSH code.
#
# ==============
# Apache License
# ==============
# Copyright 2013 Trend Micro Incorporated
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# ===========
# BSD License
# ===========
# Copyright (c) 2013, Trend Micro Incorporated
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.

# 3. Neither the name of the copyright holder nor the names of its contributors
#    may be used to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.

if(MSVC)
    add_definitions(-DTLSH_EXPORTS -DTLSH_LIB)
endif()

set(TLSH_SRCS tlsh.cpp tlsh_impl.cpp tlsh_util.cpp input_desc.cpp shared_file_functions.cpp)
add_library(tlsh_static STATIC ${TLSH_SRCS})
target_link_libraries(tlsh_static PRIVATE)
set_target_properties(tlsh_static PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/lib)
set_target_properties(tlsh_static PROPERTIES OUTPUT_NAME tlsh${BUILD_POSTFIX})

##########################
# the tlsh library is small - there is no reason to have a shared library
# it was causing problems when compiling / testing tools on Linux
##########################

if (NOT DEFINED TLSH_SHARED_LIBRARY)
    set(TLSH_SHARED_LIBRARY 0)
endif()

if(TLSH_SHARED_LIBRARY EQUAL 1)
    add_library(tlsh_shared SHARED ${TLSH_SRCS})
    target_link_libraries(tlsh_shared PRIVATE)
    set_target_properties(tlsh_shared PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/lib)
    set_target_properties(tlsh_shared PROPERTIES OUTPUT_NAME tlsh${BUILD_POSTFIX})
    set_target_properties(tlsh_shared PROPERTIES VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}"
                                                 SOVERSION "${VERSION_MAJOR}")
endif()

if(TLSH_SHARED_LIBRARY)
    install(TARGETS tlsh_static tlsh_shared DESTINATION lib)
else()
    install(TARGETS tlsh_static             DESTINATION lib)
endif()

install(FILES ../include/tlsh.h DESTINATION include/tlsh)
install(FILES ../include/tlsh_version.h DESTINATION include/tlsh)

=== debian/changelog ===
tlsh (4.12.1+ds-1) unstable; urgency=medium

  * New upstream version 4.12.1+ds
  * d/p/*: Adapt patch set to new upstream version.
  * d/control: Bump Standards-Version to 4.7.3.
  * d/copyright: Bump upstream and packaging copyright years.

 -- Sven Geuer <sge@debian.org>  Thu, 22 Jan 2026 21:24:28 +0100

=== debian/control ===
Source: tlsh
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Sven Geuer <sge@debian.org>
Section: admin
Priority: optional
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-sequence-python3,
 libpython3-all-dev,
 python3-all-dev:any,
 python3-docutils,
 python3-setuptools,
Standards-Version: 4.7.3
Homepage: https://github.com/trendmicro/tlsh
Vcs-Git: https://salsa.debian.org/pkg-security-team/tlsh.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/tlsh

Package: tlsh-tools
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: compare similar files using fuzzy hashing
 The Trend Micro Locality Sensitive Hash is a fuzzy hash algorithm that can be
 used to compare similar but not identical files.
 .
 Identifying near duplicates and similar files is known to be useful to
 identify malware samples with similar binary file structure, variants of spam
 email, or backups with corrupted files.
 .
 This package contains the tlsh_unittest utility, a command-line tool to
 generate TLSH hash values and compare TLSH hash values to determine
 similar files.

Package: libtlsh4
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: fuzzy hashing library
 The Trend Micro Locality Sensitive Hash is a fuzzy hash algorithm that can be
 used to compare similar but not identical files.
 .
 Identifying near duplicates and similar files is known to be useful to
 identify malware samples with similar binary file structure, variants of spam
 email, or backups with corrupted files.
 .
 This package contains the shared library itself.

Package: libtlsh-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libtlsh4 (= ${binary:Version}),
 ${misc:Depends},
Description: fuzzy hashing library - development files
 The Trend Micro Locality Sensitive Hash is a fuzzy hash algorithm that can be
 used to compare similar but not identical files.
 .
 Identifying near duplicates and similar files is known to be useful to
 identify malware samples with similar binary file structure, variants of spam
 email, or backups with corrupted files.
 .
 This package contains the development headers and the static library.

Package: python3-tlsh
Section: python
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: fuzzy hashing library - Python3 module
 The Trend Micro Locality Sensitive Hash is a fuzzy hash algorithm that can be
 used to compare similar but not identical files.
 .
 Identifying near duplicates and similar files is known to be useful to
 identify malware samples with similar binary file structure, variants of spam
 email, or backups with corrupted files.
 .
 This package contains the Python3 module.

=== debian/rules ===
#!/usr/bin/make -f

# Make sure lintian does not complain about missing hardenings.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export PYBUILD_NAME = tlsh

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DTLSH_SHARED_LIBRARY=1

execute_after_dh_auto_build:
	dh_auto_build --sourcedirectory=py_ext --buildsystem=pybuild

execute_after_dh_auto_install: debian/tlsh_unittest.1
	dh_auto_install --sourcedirectory=py_ext --buildsystem=pybuild

override_dh_python3:
	dh_python3 -O--sourcedirectory=py_ext -O--buildsystem=pybuild

debian/tlsh_unittest.1: debian/tlsh_unittest.1.rst
	rst2man $< $@

## tlsh 5.0.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -55,9 +55,9 @@
 
 project(TLSH)
 
-set(VERSION_MAJOR 4)
-set(VERSION_MINOR 12)
-set(VERSION_PATCH 1)
+set(VERSION_MAJOR 5)
+set(VERSION_MINOR 0)
+set(VERSION_PATCH 0)
 
 # TLSH uses only half the counting buckets.
 # It can use all the buckets now.

=== debian/changelog ===
tlsh (5.0.0+ds-1~exp1) experimental; urgency=medium

  * New upstream version 5.0.0+ds
  * d/control: Update library package name to new SONAME.
  * d/libtlsh*: Rename docs, install and symbols files according to new SONAME.
  * d/libtlsh5.symbols: Update library soname and dependency template.
  * d/t/build-test-program: Adapt test to the new ABI.
  * d/p/cmake4.patch: Simply BTS URL.
  * d/control: Drop 'Priority: optional'.
  * d/copyright: Update upstream copyright years.

 -- Sven Geuer <sge@debian.org>  Tue, 17 Feb 2026 21:01:18 +0100

tlsh (4.13.3+ds-1) UNRELEASED; urgency=medium

  * New upstream version 4.13.3+ds
  * d/p/*: Adapt patch set to new upstream version.
    - Drop distutils-to-setuptools.patch, it has been applied upstream.
    - Update cpu-agnostic-endianness.patch.
  * d/libtlsh4.symbols: Update symbols file.
  * Not released due to ABI breakage, for details see
    https://github.com/trendmicro/tlsh/issues/162.

 -- Sven Geuer <sge@debian.org>  Tue, 17 Feb 2026 12:58:12 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Sven Geuer <sge@debian.org>
 Section: admin
-Priority: optional
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
@@ -33,7 +32,7 @@
  generate TLSH hash values and compare TLSH hash values to determine
  similar files.
 
-Package: libtlsh4
+Package: libtlsh5
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -55,7 +54,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libtlsh4 (= ${binary:Version}),
+ libtlsh5 (= ${binary:Version}),
  ${misc:Depends},
 Description: fuzzy hashing library - development files
  The Trend Micro Locality Sensitive Hash is a fuzzy hash algorithm that can be

=== debian/watch ===
Version: 5
Dversion-Mangle: auto
Repacksuffix: +ds
Template: Github
Owner: trendmicro
Project: tlsh
